import { createAggregatedClient } from "@smithy/smithy-client";
import { CancelImageCreationCommand, } from "./commands/CancelImageCreationCommand";
import { CancelLifecycleExecutionCommand, } from "./commands/CancelLifecycleExecutionCommand";
import { CreateComponentCommand, } from "./commands/CreateComponentCommand";
import { CreateContainerRecipeCommand, } from "./commands/CreateContainerRecipeCommand";
import { CreateDistributionConfigurationCommand, } from "./commands/CreateDistributionConfigurationCommand";
import { CreateImageCommand } from "./commands/CreateImageCommand";
import { CreateImagePipelineCommand, } from "./commands/CreateImagePipelineCommand";
import { CreateImageRecipeCommand, } from "./commands/CreateImageRecipeCommand";
import { CreateInfrastructureConfigurationCommand, } from "./commands/CreateInfrastructureConfigurationCommand";
import { CreateLifecyclePolicyCommand, } from "./commands/CreateLifecyclePolicyCommand";
import { CreateWorkflowCommand, } from "./commands/CreateWorkflowCommand";
import { DeleteComponentCommand, } from "./commands/DeleteComponentCommand";
import { DeleteContainerRecipeCommand, } from "./commands/DeleteContainerRecipeCommand";
import { DeleteDistributionConfigurationCommand, } from "./commands/DeleteDistributionConfigurationCommand";
import { DeleteImageCommand } from "./commands/DeleteImageCommand";
import { DeleteImagePipelineCommand, } from "./commands/DeleteImagePipelineCommand";
import { DeleteImageRecipeCommand, } from "./commands/DeleteImageRecipeCommand";
import { DeleteInfrastructureConfigurationCommand, } from "./commands/DeleteInfrastructureConfigurationCommand";
import { DeleteLifecyclePolicyCommand, } from "./commands/DeleteLifecyclePolicyCommand";
import { DeleteWorkflowCommand, } from "./commands/DeleteWorkflowCommand";
import { GetComponentCommand, } from "./commands/GetComponentCommand";
import { GetComponentPolicyCommand, } from "./commands/GetComponentPolicyCommand";
import { GetContainerRecipeCommand, } from "./commands/GetContainerRecipeCommand";
import { GetContainerRecipePolicyCommand, } from "./commands/GetContainerRecipePolicyCommand";
import { GetDistributionConfigurationCommand, } from "./commands/GetDistributionConfigurationCommand";
import { GetImageCommand } from "./commands/GetImageCommand";
import { GetImagePipelineCommand, } from "./commands/GetImagePipelineCommand";
import { GetImagePolicyCommand, } from "./commands/GetImagePolicyCommand";
import { GetImageRecipeCommand, } from "./commands/GetImageRecipeCommand";
import { GetImageRecipePolicyCommand, } from "./commands/GetImageRecipePolicyCommand";
import { GetInfrastructureConfigurationCommand, } from "./commands/GetInfrastructureConfigurationCommand";
import { GetLifecycleExecutionCommand, } from "./commands/GetLifecycleExecutionCommand";
import { GetLifecyclePolicyCommand, } from "./commands/GetLifecyclePolicyCommand";
import { GetWorkflowCommand } from "./commands/GetWorkflowCommand";
import { GetWorkflowExecutionCommand, } from "./commands/GetWorkflowExecutionCommand";
import { GetWorkflowStepExecutionCommand, } from "./commands/GetWorkflowStepExecutionCommand";
import { ImportComponentCommand, } from "./commands/ImportComponentCommand";
import { ImportVmImageCommand, } from "./commands/ImportVmImageCommand";
import { ListComponentBuildVersionsCommand, } from "./commands/ListComponentBuildVersionsCommand";
import { ListComponentsCommand, } from "./commands/ListComponentsCommand";
import { ListContainerRecipesCommand, } from "./commands/ListContainerRecipesCommand";
import { ListDistributionConfigurationsCommand, } from "./commands/ListDistributionConfigurationsCommand";
import { ListImageBuildVersionsCommand, } from "./commands/ListImageBuildVersionsCommand";
import { ListImagePackagesCommand, } from "./commands/ListImagePackagesCommand";
import { ListImagePipelineImagesCommand, } from "./commands/ListImagePipelineImagesCommand";
import { ListImagePipelinesCommand, } from "./commands/ListImagePipelinesCommand";
import { ListImageRecipesCommand, } from "./commands/ListImageRecipesCommand";
import { ListImageScanFindingAggregationsCommand, } from "./commands/ListImageScanFindingAggregationsCommand";
import { ListImageScanFindingsCommand, } from "./commands/ListImageScanFindingsCommand";
import { ListImagesCommand } from "./commands/ListImagesCommand";
import { ListInfrastructureConfigurationsCommand, } from "./commands/ListInfrastructureConfigurationsCommand";
import { ListLifecycleExecutionResourcesCommand, } from "./commands/ListLifecycleExecutionResourcesCommand";
import { ListLifecycleExecutionsCommand, } from "./commands/ListLifecycleExecutionsCommand";
import { ListLifecyclePoliciesCommand, } from "./commands/ListLifecyclePoliciesCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { ListWaitingWorkflowStepsCommand, } from "./commands/ListWaitingWorkflowStepsCommand";
import { ListWorkflowBuildVersionsCommand, } from "./commands/ListWorkflowBuildVersionsCommand";
import { ListWorkflowExecutionsCommand, } from "./commands/ListWorkflowExecutionsCommand";
import { ListWorkflowsCommand, } from "./commands/ListWorkflowsCommand";
import { ListWorkflowStepExecutionsCommand, } from "./commands/ListWorkflowStepExecutionsCommand";
import { PutComponentPolicyCommand, } from "./commands/PutComponentPolicyCommand";
import { PutContainerRecipePolicyCommand, } from "./commands/PutContainerRecipePolicyCommand";
import { PutImagePolicyCommand, } from "./commands/PutImagePolicyCommand";
import { PutImageRecipePolicyCommand, } from "./commands/PutImageRecipePolicyCommand";
import { SendWorkflowStepActionCommand, } from "./commands/SendWorkflowStepActionCommand";
import { StartImagePipelineExecutionCommand, } from "./commands/StartImagePipelineExecutionCommand";
import { StartResourceStateUpdateCommand, } from "./commands/StartResourceStateUpdateCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
import { UpdateDistributionConfigurationCommand, } from "./commands/UpdateDistributionConfigurationCommand";
import { UpdateImagePipelineCommand, } from "./commands/UpdateImagePipelineCommand";
import { UpdateInfrastructureConfigurationCommand, } from "./commands/UpdateInfrastructureConfigurationCommand";
import { UpdateLifecyclePolicyCommand, } from "./commands/UpdateLifecyclePolicyCommand";
import { ImagebuilderClient } from "./ImagebuilderClient";
const commands = {
    CancelImageCreationCommand,
    CancelLifecycleExecutionCommand,
    CreateComponentCommand,
    CreateContainerRecipeCommand,
    CreateDistributionConfigurationCommand,
    CreateImageCommand,
    CreateImagePipelineCommand,
    CreateImageRecipeCommand,
    CreateInfrastructureConfigurationCommand,
    CreateLifecyclePolicyCommand,
    CreateWorkflowCommand,
    DeleteComponentCommand,
    DeleteContainerRecipeCommand,
    DeleteDistributionConfigurationCommand,
    DeleteImageCommand,
    DeleteImagePipelineCommand,
    DeleteImageRecipeCommand,
    DeleteInfrastructureConfigurationCommand,
    DeleteLifecyclePolicyCommand,
    DeleteWorkflowCommand,
    GetComponentCommand,
    GetComponentPolicyCommand,
    GetContainerRecipeCommand,
    GetContainerRecipePolicyCommand,
    GetDistributionConfigurationCommand,
    GetImageCommand,
    GetImagePipelineCommand,
    GetImagePolicyCommand,
    GetImageRecipeCommand,
    GetImageRecipePolicyCommand,
    GetInfrastructureConfigurationCommand,
    GetLifecycleExecutionCommand,
    GetLifecyclePolicyCommand,
    GetWorkflowCommand,
    GetWorkflowExecutionCommand,
    GetWorkflowStepExecutionCommand,
    ImportComponentCommand,
    ImportVmImageCommand,
    ListComponentBuildVersionsCommand,
    ListComponentsCommand,
    ListContainerRecipesCommand,
    ListDistributionConfigurationsCommand,
    ListImageBuildVersionsCommand,
    ListImagePackagesCommand,
    ListImagePipelineImagesCommand,
    ListImagePipelinesCommand,
    ListImageRecipesCommand,
    ListImagesCommand,
    ListImageScanFindingAggregationsCommand,
    ListImageScanFindingsCommand,
    ListInfrastructureConfigurationsCommand,
    ListLifecycleExecutionResourcesCommand,
    ListLifecycleExecutionsCommand,
    ListLifecyclePoliciesCommand,
    ListTagsForResourceCommand,
    ListWaitingWorkflowStepsCommand,
    ListWorkflowBuildVersionsCommand,
    ListWorkflowExecutionsCommand,
    ListWorkflowsCommand,
    ListWorkflowStepExecutionsCommand,
    PutComponentPolicyCommand,
    PutContainerRecipePolicyCommand,
    PutImagePolicyCommand,
    PutImageRecipePolicyCommand,
    SendWorkflowStepActionCommand,
    StartImagePipelineExecutionCommand,
    StartResourceStateUpdateCommand,
    TagResourceCommand,
    UntagResourceCommand,
    UpdateDistributionConfigurationCommand,
    UpdateImagePipelineCommand,
    UpdateInfrastructureConfigurationCommand,
    UpdateLifecyclePolicyCommand,
};
export class Imagebuilder extends ImagebuilderClient {
}
createAggregatedClient(commands, Imagebuilder);
