import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_CancelLifecycleExecutionCommand, se_CancelLifecycleExecutionCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class CancelLifecycleExecutionCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("imagebuilder", "CancelLifecycleExecution", {})
    .n("ImagebuilderClient", "CancelLifecycleExecutionCommand")
    .f(void 0, void 0)
    .ser(se_CancelLifecycleExecutionCommand)
    .de(de_CancelLifecycleExecutionCommand)
    .build() {
}
