import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { ImagebuilderClientResolvedConfig } from "../ImagebuilderClient";
export interface ImagebuilderHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface ImagebuilderHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    ImagebuilderClientResolvedConfig,
    HandlerExecutionContext,
    ImagebuilderHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultImagebuilderHttpAuthSchemeParametersProvider: (
  config: ImagebuilderClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<ImagebuilderHttpAuthSchemeParameters>;
export interface ImagebuilderHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<ImagebuilderHttpAuthSchemeParameters> {}
export declare const defaultImagebuilderHttpAuthSchemeProvider: ImagebuilderHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: ImagebuilderHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: ImagebuilderHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
