import { createAggregatedClient } from "@smithy/smithy-client";
import { AcceptInboundConnectionCommand, } from "./commands/AcceptInboundConnectionCommand";
import { AddDataSourceCommand, } from "./commands/AddDataSourceCommand";
import { AddTagsCommand } from "./commands/AddTagsCommand";
import { AssociatePackageCommand, } from "./commands/AssociatePackageCommand";
import { AuthorizeVpcEndpointAccessCommand, } from "./commands/AuthorizeVpcEndpointAccessCommand";
import { CancelDomainConfigChangeCommand, } from "./commands/CancelDomainConfigChangeCommand";
import { CancelServiceSoftwareUpdateCommand, } from "./commands/CancelServiceSoftwareUpdateCommand";
import { CreateDomainCommand, } from "./commands/CreateDomainCommand";
import { CreateOutboundConnectionCommand, } from "./commands/CreateOutboundConnectionCommand";
import { CreatePackageCommand, } from "./commands/CreatePackageCommand";
import { CreateVpcEndpointCommand, } from "./commands/CreateVpcEndpointCommand";
import { DeleteDataSourceCommand, } from "./commands/DeleteDataSourceCommand";
import { DeleteDomainCommand, } from "./commands/DeleteDomainCommand";
import { DeleteInboundConnectionCommand, } from "./commands/DeleteInboundConnectionCommand";
import { DeleteOutboundConnectionCommand, } from "./commands/DeleteOutboundConnectionCommand";
import { DeletePackageCommand, } from "./commands/DeletePackageCommand";
import { DeleteVpcEndpointCommand, } from "./commands/DeleteVpcEndpointCommand";
import { DescribeDomainAutoTunesCommand, } from "./commands/DescribeDomainAutoTunesCommand";
import { DescribeDomainChangeProgressCommand, } from "./commands/DescribeDomainChangeProgressCommand";
import { DescribeDomainCommand, } from "./commands/DescribeDomainCommand";
import { DescribeDomainConfigCommand, } from "./commands/DescribeDomainConfigCommand";
import { DescribeDomainHealthCommand, } from "./commands/DescribeDomainHealthCommand";
import { DescribeDomainNodesCommand, } from "./commands/DescribeDomainNodesCommand";
import { DescribeDomainsCommand, } from "./commands/DescribeDomainsCommand";
import { DescribeDryRunProgressCommand, } from "./commands/DescribeDryRunProgressCommand";
import { DescribeInboundConnectionsCommand, } from "./commands/DescribeInboundConnectionsCommand";
import { DescribeInstanceTypeLimitsCommand, } from "./commands/DescribeInstanceTypeLimitsCommand";
import { DescribeOutboundConnectionsCommand, } from "./commands/DescribeOutboundConnectionsCommand";
import { DescribePackagesCommand, } from "./commands/DescribePackagesCommand";
import { DescribeReservedInstanceOfferingsCommand, } from "./commands/DescribeReservedInstanceOfferingsCommand";
import { DescribeReservedInstancesCommand, } from "./commands/DescribeReservedInstancesCommand";
import { DescribeVpcEndpointsCommand, } from "./commands/DescribeVpcEndpointsCommand";
import { DissociatePackageCommand, } from "./commands/DissociatePackageCommand";
import { GetCompatibleVersionsCommand, } from "./commands/GetCompatibleVersionsCommand";
import { GetDataSourceCommand, } from "./commands/GetDataSourceCommand";
import { GetDomainMaintenanceStatusCommand, } from "./commands/GetDomainMaintenanceStatusCommand";
import { GetPackageVersionHistoryCommand, } from "./commands/GetPackageVersionHistoryCommand";
import { GetUpgradeHistoryCommand, } from "./commands/GetUpgradeHistoryCommand";
import { GetUpgradeStatusCommand, } from "./commands/GetUpgradeStatusCommand";
import { ListDataSourcesCommand, } from "./commands/ListDataSourcesCommand";
import { ListDomainMaintenancesCommand, } from "./commands/ListDomainMaintenancesCommand";
import { ListDomainNamesCommand, } from "./commands/ListDomainNamesCommand";
import { ListDomainsForPackageCommand, } from "./commands/ListDomainsForPackageCommand";
import { ListInstanceTypeDetailsCommand, } from "./commands/ListInstanceTypeDetailsCommand";
import { ListPackagesForDomainCommand, } from "./commands/ListPackagesForDomainCommand";
import { ListScheduledActionsCommand, } from "./commands/ListScheduledActionsCommand";
import { ListTagsCommand } from "./commands/ListTagsCommand";
import { ListVersionsCommand, } from "./commands/ListVersionsCommand";
import { ListVpcEndpointAccessCommand, } from "./commands/ListVpcEndpointAccessCommand";
import { ListVpcEndpointsCommand, } from "./commands/ListVpcEndpointsCommand";
import { ListVpcEndpointsForDomainCommand, } from "./commands/ListVpcEndpointsForDomainCommand";
import { PurchaseReservedInstanceOfferingCommand, } from "./commands/PurchaseReservedInstanceOfferingCommand";
import { RejectInboundConnectionCommand, } from "./commands/RejectInboundConnectionCommand";
import { RemoveTagsCommand } from "./commands/RemoveTagsCommand";
import { RevokeVpcEndpointAccessCommand, } from "./commands/RevokeVpcEndpointAccessCommand";
import { StartDomainMaintenanceCommand, } from "./commands/StartDomainMaintenanceCommand";
import { StartServiceSoftwareUpdateCommand, } from "./commands/StartServiceSoftwareUpdateCommand";
import { UpdateDataSourceCommand, } from "./commands/UpdateDataSourceCommand";
import { UpdateDomainConfigCommand, } from "./commands/UpdateDomainConfigCommand";
import { UpdatePackageCommand, } from "./commands/UpdatePackageCommand";
import { UpdateScheduledActionCommand, } from "./commands/UpdateScheduledActionCommand";
import { UpdateVpcEndpointCommand, } from "./commands/UpdateVpcEndpointCommand";
import { UpgradeDomainCommand, } from "./commands/UpgradeDomainCommand";
import { OpenSearchClient } from "./OpenSearchClient";
const commands = {
    AcceptInboundConnectionCommand,
    AddDataSourceCommand,
    AddTagsCommand,
    AssociatePackageCommand,
    AuthorizeVpcEndpointAccessCommand,
    CancelDomainConfigChangeCommand,
    CancelServiceSoftwareUpdateCommand,
    CreateDomainCommand,
    CreateOutboundConnectionCommand,
    CreatePackageCommand,
    CreateVpcEndpointCommand,
    DeleteDataSourceCommand,
    DeleteDomainCommand,
    DeleteInboundConnectionCommand,
    DeleteOutboundConnectionCommand,
    DeletePackageCommand,
    DeleteVpcEndpointCommand,
    DescribeDomainCommand,
    DescribeDomainAutoTunesCommand,
    DescribeDomainChangeProgressCommand,
    DescribeDomainConfigCommand,
    DescribeDomainHealthCommand,
    DescribeDomainNodesCommand,
    DescribeDomainsCommand,
    DescribeDryRunProgressCommand,
    DescribeInboundConnectionsCommand,
    DescribeInstanceTypeLimitsCommand,
    DescribeOutboundConnectionsCommand,
    DescribePackagesCommand,
    DescribeReservedInstanceOfferingsCommand,
    DescribeReservedInstancesCommand,
    DescribeVpcEndpointsCommand,
    DissociatePackageCommand,
    GetCompatibleVersionsCommand,
    GetDataSourceCommand,
    GetDomainMaintenanceStatusCommand,
    GetPackageVersionHistoryCommand,
    GetUpgradeHistoryCommand,
    GetUpgradeStatusCommand,
    ListDataSourcesCommand,
    ListDomainMaintenancesCommand,
    ListDomainNamesCommand,
    ListDomainsForPackageCommand,
    ListInstanceTypeDetailsCommand,
    ListPackagesForDomainCommand,
    ListScheduledActionsCommand,
    ListTagsCommand,
    ListVersionsCommand,
    ListVpcEndpointAccessCommand,
    ListVpcEndpointsCommand,
    ListVpcEndpointsForDomainCommand,
    PurchaseReservedInstanceOfferingCommand,
    RejectInboundConnectionCommand,
    RemoveTagsCommand,
    RevokeVpcEndpointAccessCommand,
    StartDomainMaintenanceCommand,
    StartServiceSoftwareUpdateCommand,
    UpdateDataSourceCommand,
    UpdateDomainConfigCommand,
    UpdatePackageCommand,
    UpdateScheduledActionCommand,
    UpdateVpcEndpointCommand,
    UpgradeDomainCommand,
};
export class OpenSearch extends OpenSearchClient {
}
createAggregatedClient(commands, OpenSearch);
