import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { UpdateDomainConfigRequestFilterSensitiveLog, } from "../models/models_0";
import { de_UpdateDomainConfigCommand, se_UpdateDomainConfigCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateDomainConfigCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AmazonOpenSearchService", "UpdateDomainConfig", {})
    .n("OpenSearchClient", "UpdateDomainConfigCommand")
    .f(UpdateDomainConfigRequestFilterSensitiveLog, void 0)
    .ser(se_UpdateDomainConfigCommand)
    .de(de_UpdateDomainConfigCommand)
    .build() {
}
