/**
 * <p>Use the Amazon OpenSearch Service configuration API to create, configure, and manage
 *    OpenSearch Service domains. The endpoint for configuration service requests is Region specific:
 *     es.<i>region</i>.amazonaws.com. For example, es.us-east-1.amazonaws.com. For a
 *    current list of supported Regions and endpoints, see <a href="https://docs.aws.amazon.com/general/latest/gr/rande.html#service-regions">Amazon Web Services service
 *    endpoints</a>.</p>
 *
 * @packageDocumentation
 */
export * from "./OpenSearchClient";
export * from "./OpenSearch";
export { ClientInputEndpointParameters } from "./endpoint/EndpointParameters";
export type { RuntimeExtension } from "./runtimeExtensions";
export type { OpenSearchExtensionConfiguration } from "./extensionConfiguration";
export * from "./commands";
export * from "./pagination";
export * from "./models";
export { OpenSearchServiceException } from "./models/OpenSearchServiceException";
