import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AcceptInboundConnectionCommandInput, AcceptInboundConnectionCommandOutput } from "../commands/AcceptInboundConnectionCommand";
import { AddDataSourceCommandInput, AddDataSourceCommandOutput } from "../commands/AddDataSourceCommand";
import { AddTagsCommandInput, AddTagsCommandOutput } from "../commands/AddTagsCommand";
import { AssociatePackageCommandInput, AssociatePackageCommandOutput } from "../commands/AssociatePackageCommand";
import { AuthorizeVpcEndpointAccessCommandInput, AuthorizeVpcEndpointAccessCommandOutput } from "../commands/AuthorizeVpcEndpointAccessCommand";
import { CancelDomainConfigChangeCommandInput, CancelDomainConfigChangeCommandOutput } from "../commands/CancelDomainConfigChangeCommand";
import { CancelServiceSoftwareUpdateCommandInput, CancelServiceSoftwareUpdateCommandOutput } from "../commands/CancelServiceSoftwareUpdateCommand";
import { CreateDomainCommandInput, CreateDomainCommandOutput } from "../commands/CreateDomainCommand";
import { CreateOutboundConnectionCommandInput, CreateOutboundConnectionCommandOutput } from "../commands/CreateOutboundConnectionCommand";
import { CreatePackageCommandInput, CreatePackageCommandOutput } from "../commands/CreatePackageCommand";
import { CreateVpcEndpointCommandInput, CreateVpcEndpointCommandOutput } from "../commands/CreateVpcEndpointCommand";
import { DeleteDataSourceCommandInput, DeleteDataSourceCommandOutput } from "../commands/DeleteDataSourceCommand";
import { DeleteDomainCommandInput, DeleteDomainCommandOutput } from "../commands/DeleteDomainCommand";
import { DeleteInboundConnectionCommandInput, DeleteInboundConnectionCommandOutput } from "../commands/DeleteInboundConnectionCommand";
import { DeleteOutboundConnectionCommandInput, DeleteOutboundConnectionCommandOutput } from "../commands/DeleteOutboundConnectionCommand";
import { DeletePackageCommandInput, DeletePackageCommandOutput } from "../commands/DeletePackageCommand";
import { DeleteVpcEndpointCommandInput, DeleteVpcEndpointCommandOutput } from "../commands/DeleteVpcEndpointCommand";
import { DescribeDomainAutoTunesCommandInput, DescribeDomainAutoTunesCommandOutput } from "../commands/DescribeDomainAutoTunesCommand";
import { DescribeDomainChangeProgressCommandInput, DescribeDomainChangeProgressCommandOutput } from "../commands/DescribeDomainChangeProgressCommand";
import { DescribeDomainCommandInput, DescribeDomainCommandOutput } from "../commands/DescribeDomainCommand";
import { DescribeDomainConfigCommandInput, DescribeDomainConfigCommandOutput } from "../commands/DescribeDomainConfigCommand";
import { DescribeDomainHealthCommandInput, DescribeDomainHealthCommandOutput } from "../commands/DescribeDomainHealthCommand";
import { DescribeDomainNodesCommandInput, DescribeDomainNodesCommandOutput } from "../commands/DescribeDomainNodesCommand";
import { DescribeDomainsCommandInput, DescribeDomainsCommandOutput } from "../commands/DescribeDomainsCommand";
import { DescribeDryRunProgressCommandInput, DescribeDryRunProgressCommandOutput } from "../commands/DescribeDryRunProgressCommand";
import { DescribeInboundConnectionsCommandInput, DescribeInboundConnectionsCommandOutput } from "../commands/DescribeInboundConnectionsCommand";
import { DescribeInstanceTypeLimitsCommandInput, DescribeInstanceTypeLimitsCommandOutput } from "../commands/DescribeInstanceTypeLimitsCommand";
import { DescribeOutboundConnectionsCommandInput, DescribeOutboundConnectionsCommandOutput } from "../commands/DescribeOutboundConnectionsCommand";
import { DescribePackagesCommandInput, DescribePackagesCommandOutput } from "../commands/DescribePackagesCommand";
import { DescribeReservedInstanceOfferingsCommandInput, DescribeReservedInstanceOfferingsCommandOutput } from "../commands/DescribeReservedInstanceOfferingsCommand";
import { DescribeReservedInstancesCommandInput, DescribeReservedInstancesCommandOutput } from "../commands/DescribeReservedInstancesCommand";
import { DescribeVpcEndpointsCommandInput, DescribeVpcEndpointsCommandOutput } from "../commands/DescribeVpcEndpointsCommand";
import { DissociatePackageCommandInput, DissociatePackageCommandOutput } from "../commands/DissociatePackageCommand";
import { GetCompatibleVersionsCommandInput, GetCompatibleVersionsCommandOutput } from "../commands/GetCompatibleVersionsCommand";
import { GetDataSourceCommandInput, GetDataSourceCommandOutput } from "../commands/GetDataSourceCommand";
import { GetDomainMaintenanceStatusCommandInput, GetDomainMaintenanceStatusCommandOutput } from "../commands/GetDomainMaintenanceStatusCommand";
import { GetPackageVersionHistoryCommandInput, GetPackageVersionHistoryCommandOutput } from "../commands/GetPackageVersionHistoryCommand";
import { GetUpgradeHistoryCommandInput, GetUpgradeHistoryCommandOutput } from "../commands/GetUpgradeHistoryCommand";
import { GetUpgradeStatusCommandInput, GetUpgradeStatusCommandOutput } from "../commands/GetUpgradeStatusCommand";
import { ListDataSourcesCommandInput, ListDataSourcesCommandOutput } from "../commands/ListDataSourcesCommand";
import { ListDomainMaintenancesCommandInput, ListDomainMaintenancesCommandOutput } from "../commands/ListDomainMaintenancesCommand";
import { ListDomainNamesCommandInput, ListDomainNamesCommandOutput } from "../commands/ListDomainNamesCommand";
import { ListDomainsForPackageCommandInput, ListDomainsForPackageCommandOutput } from "../commands/ListDomainsForPackageCommand";
import { ListInstanceTypeDetailsCommandInput, ListInstanceTypeDetailsCommandOutput } from "../commands/ListInstanceTypeDetailsCommand";
import { ListPackagesForDomainCommandInput, ListPackagesForDomainCommandOutput } from "../commands/ListPackagesForDomainCommand";
import { ListScheduledActionsCommandInput, ListScheduledActionsCommandOutput } from "../commands/ListScheduledActionsCommand";
import { ListTagsCommandInput, ListTagsCommandOutput } from "../commands/ListTagsCommand";
import { ListVersionsCommandInput, ListVersionsCommandOutput } from "../commands/ListVersionsCommand";
import { ListVpcEndpointAccessCommandInput, ListVpcEndpointAccessCommandOutput } from "../commands/ListVpcEndpointAccessCommand";
import { ListVpcEndpointsCommandInput, ListVpcEndpointsCommandOutput } from "../commands/ListVpcEndpointsCommand";
import { ListVpcEndpointsForDomainCommandInput, ListVpcEndpointsForDomainCommandOutput } from "../commands/ListVpcEndpointsForDomainCommand";
import { PurchaseReservedInstanceOfferingCommandInput, PurchaseReservedInstanceOfferingCommandOutput } from "../commands/PurchaseReservedInstanceOfferingCommand";
import { RejectInboundConnectionCommandInput, RejectInboundConnectionCommandOutput } from "../commands/RejectInboundConnectionCommand";
import { RemoveTagsCommandInput, RemoveTagsCommandOutput } from "../commands/RemoveTagsCommand";
import { RevokeVpcEndpointAccessCommandInput, RevokeVpcEndpointAccessCommandOutput } from "../commands/RevokeVpcEndpointAccessCommand";
import { StartDomainMaintenanceCommandInput, StartDomainMaintenanceCommandOutput } from "../commands/StartDomainMaintenanceCommand";
import { StartServiceSoftwareUpdateCommandInput, StartServiceSoftwareUpdateCommandOutput } from "../commands/StartServiceSoftwareUpdateCommand";
import { UpdateDataSourceCommandInput, UpdateDataSourceCommandOutput } from "../commands/UpdateDataSourceCommand";
import { UpdateDomainConfigCommandInput, UpdateDomainConfigCommandOutput } from "../commands/UpdateDomainConfigCommand";
import { UpdatePackageCommandInput, UpdatePackageCommandOutput } from "../commands/UpdatePackageCommand";
import { UpdateScheduledActionCommandInput, UpdateScheduledActionCommandOutput } from "../commands/UpdateScheduledActionCommand";
import { UpdateVpcEndpointCommandInput, UpdateVpcEndpointCommandOutput } from "../commands/UpdateVpcEndpointCommand";
import { UpgradeDomainCommandInput, UpgradeDomainCommandOutput } from "../commands/UpgradeDomainCommand";
/**
 * serializeAws_restJson1AcceptInboundConnectionCommand
 */
export declare const se_AcceptInboundConnectionCommand: (input: AcceptInboundConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1AddDataSourceCommand
 */
export declare const se_AddDataSourceCommand: (input: AddDataSourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1AddTagsCommand
 */
export declare const se_AddTagsCommand: (input: AddTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1AssociatePackageCommand
 */
export declare const se_AssociatePackageCommand: (input: AssociatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1AuthorizeVpcEndpointAccessCommand
 */
export declare const se_AuthorizeVpcEndpointAccessCommand: (input: AuthorizeVpcEndpointAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CancelDomainConfigChangeCommand
 */
export declare const se_CancelDomainConfigChangeCommand: (input: CancelDomainConfigChangeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CancelServiceSoftwareUpdateCommand
 */
export declare const se_CancelServiceSoftwareUpdateCommand: (input: CancelServiceSoftwareUpdateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateDomainCommand
 */
export declare const se_CreateDomainCommand: (input: CreateDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateOutboundConnectionCommand
 */
export declare const se_CreateOutboundConnectionCommand: (input: CreateOutboundConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreatePackageCommand
 */
export declare const se_CreatePackageCommand: (input: CreatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateVpcEndpointCommand
 */
export declare const se_CreateVpcEndpointCommand: (input: CreateVpcEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDataSourceCommand
 */
export declare const se_DeleteDataSourceCommand: (input: DeleteDataSourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDomainCommand
 */
export declare const se_DeleteDomainCommand: (input: DeleteDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteInboundConnectionCommand
 */
export declare const se_DeleteInboundConnectionCommand: (input: DeleteInboundConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteOutboundConnectionCommand
 */
export declare const se_DeleteOutboundConnectionCommand: (input: DeleteOutboundConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeletePackageCommand
 */
export declare const se_DeletePackageCommand: (input: DeletePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteVpcEndpointCommand
 */
export declare const se_DeleteVpcEndpointCommand: (input: DeleteVpcEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDomainCommand
 */
export declare const se_DescribeDomainCommand: (input: DescribeDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDomainAutoTunesCommand
 */
export declare const se_DescribeDomainAutoTunesCommand: (input: DescribeDomainAutoTunesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDomainChangeProgressCommand
 */
export declare const se_DescribeDomainChangeProgressCommand: (input: DescribeDomainChangeProgressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDomainConfigCommand
 */
export declare const se_DescribeDomainConfigCommand: (input: DescribeDomainConfigCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDomainHealthCommand
 */
export declare const se_DescribeDomainHealthCommand: (input: DescribeDomainHealthCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDomainNodesCommand
 */
export declare const se_DescribeDomainNodesCommand: (input: DescribeDomainNodesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDomainsCommand
 */
export declare const se_DescribeDomainsCommand: (input: DescribeDomainsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeDryRunProgressCommand
 */
export declare const se_DescribeDryRunProgressCommand: (input: DescribeDryRunProgressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeInboundConnectionsCommand
 */
export declare const se_DescribeInboundConnectionsCommand: (input: DescribeInboundConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeInstanceTypeLimitsCommand
 */
export declare const se_DescribeInstanceTypeLimitsCommand: (input: DescribeInstanceTypeLimitsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeOutboundConnectionsCommand
 */
export declare const se_DescribeOutboundConnectionsCommand: (input: DescribeOutboundConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribePackagesCommand
 */
export declare const se_DescribePackagesCommand: (input: DescribePackagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeReservedInstanceOfferingsCommand
 */
export declare const se_DescribeReservedInstanceOfferingsCommand: (input: DescribeReservedInstanceOfferingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeReservedInstancesCommand
 */
export declare const se_DescribeReservedInstancesCommand: (input: DescribeReservedInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DescribeVpcEndpointsCommand
 */
export declare const se_DescribeVpcEndpointsCommand: (input: DescribeVpcEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DissociatePackageCommand
 */
export declare const se_DissociatePackageCommand: (input: DissociatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetCompatibleVersionsCommand
 */
export declare const se_GetCompatibleVersionsCommand: (input: GetCompatibleVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDataSourceCommand
 */
export declare const se_GetDataSourceCommand: (input: GetDataSourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDomainMaintenanceStatusCommand
 */
export declare const se_GetDomainMaintenanceStatusCommand: (input: GetDomainMaintenanceStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetPackageVersionHistoryCommand
 */
export declare const se_GetPackageVersionHistoryCommand: (input: GetPackageVersionHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetUpgradeHistoryCommand
 */
export declare const se_GetUpgradeHistoryCommand: (input: GetUpgradeHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetUpgradeStatusCommand
 */
export declare const se_GetUpgradeStatusCommand: (input: GetUpgradeStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListDataSourcesCommand
 */
export declare const se_ListDataSourcesCommand: (input: ListDataSourcesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListDomainMaintenancesCommand
 */
export declare const se_ListDomainMaintenancesCommand: (input: ListDomainMaintenancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListDomainNamesCommand
 */
export declare const se_ListDomainNamesCommand: (input: ListDomainNamesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListDomainsForPackageCommand
 */
export declare const se_ListDomainsForPackageCommand: (input: ListDomainsForPackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListInstanceTypeDetailsCommand
 */
export declare const se_ListInstanceTypeDetailsCommand: (input: ListInstanceTypeDetailsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListPackagesForDomainCommand
 */
export declare const se_ListPackagesForDomainCommand: (input: ListPackagesForDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListScheduledActionsCommand
 */
export declare const se_ListScheduledActionsCommand: (input: ListScheduledActionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListTagsCommand
 */
export declare const se_ListTagsCommand: (input: ListTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListVersionsCommand
 */
export declare const se_ListVersionsCommand: (input: ListVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListVpcEndpointAccessCommand
 */
export declare const se_ListVpcEndpointAccessCommand: (input: ListVpcEndpointAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListVpcEndpointsCommand
 */
export declare const se_ListVpcEndpointsCommand: (input: ListVpcEndpointsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ListVpcEndpointsForDomainCommand
 */
export declare const se_ListVpcEndpointsForDomainCommand: (input: ListVpcEndpointsForDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PurchaseReservedInstanceOfferingCommand
 */
export declare const se_PurchaseReservedInstanceOfferingCommand: (input: PurchaseReservedInstanceOfferingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1RejectInboundConnectionCommand
 */
export declare const se_RejectInboundConnectionCommand: (input: RejectInboundConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1RemoveTagsCommand
 */
export declare const se_RemoveTagsCommand: (input: RemoveTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1RevokeVpcEndpointAccessCommand
 */
export declare const se_RevokeVpcEndpointAccessCommand: (input: RevokeVpcEndpointAccessCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StartDomainMaintenanceCommand
 */
export declare const se_StartDomainMaintenanceCommand: (input: StartDomainMaintenanceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1StartServiceSoftwareUpdateCommand
 */
export declare const se_StartServiceSoftwareUpdateCommand: (input: StartServiceSoftwareUpdateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateDataSourceCommand
 */
export declare const se_UpdateDataSourceCommand: (input: UpdateDataSourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateDomainConfigCommand
 */
export declare const se_UpdateDomainConfigCommand: (input: UpdateDomainConfigCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdatePackageCommand
 */
export declare const se_UpdatePackageCommand: (input: UpdatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateScheduledActionCommand
 */
export declare const se_UpdateScheduledActionCommand: (input: UpdateScheduledActionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateVpcEndpointCommand
 */
export declare const se_UpdateVpcEndpointCommand: (input: UpdateVpcEndpointCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpgradeDomainCommand
 */
export declare const se_UpgradeDomainCommand: (input: UpgradeDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_restJson1AcceptInboundConnectionCommand
 */
export declare const de_AcceptInboundConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptInboundConnectionCommandOutput>;
/**
 * deserializeAws_restJson1AddDataSourceCommand
 */
export declare const de_AddDataSourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AddDataSourceCommandOutput>;
/**
 * deserializeAws_restJson1AddTagsCommand
 */
export declare const de_AddTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AddTagsCommandOutput>;
/**
 * deserializeAws_restJson1AssociatePackageCommand
 */
export declare const de_AssociatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociatePackageCommandOutput>;
/**
 * deserializeAws_restJson1AuthorizeVpcEndpointAccessCommand
 */
export declare const de_AuthorizeVpcEndpointAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AuthorizeVpcEndpointAccessCommandOutput>;
/**
 * deserializeAws_restJson1CancelDomainConfigChangeCommand
 */
export declare const de_CancelDomainConfigChangeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelDomainConfigChangeCommandOutput>;
/**
 * deserializeAws_restJson1CancelServiceSoftwareUpdateCommand
 */
export declare const de_CancelServiceSoftwareUpdateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelServiceSoftwareUpdateCommandOutput>;
/**
 * deserializeAws_restJson1CreateDomainCommand
 */
export declare const de_CreateDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDomainCommandOutput>;
/**
 * deserializeAws_restJson1CreateOutboundConnectionCommand
 */
export declare const de_CreateOutboundConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateOutboundConnectionCommandOutput>;
/**
 * deserializeAws_restJson1CreatePackageCommand
 */
export declare const de_CreatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePackageCommandOutput>;
/**
 * deserializeAws_restJson1CreateVpcEndpointCommand
 */
export declare const de_CreateVpcEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpcEndpointCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDataSourceCommand
 */
export declare const de_DeleteDataSourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDataSourceCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDomainCommand
 */
export declare const de_DeleteDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDomainCommandOutput>;
/**
 * deserializeAws_restJson1DeleteInboundConnectionCommand
 */
export declare const de_DeleteInboundConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInboundConnectionCommandOutput>;
/**
 * deserializeAws_restJson1DeleteOutboundConnectionCommand
 */
export declare const de_DeleteOutboundConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteOutboundConnectionCommandOutput>;
/**
 * deserializeAws_restJson1DeletePackageCommand
 */
export declare const de_DeletePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePackageCommandOutput>;
/**
 * deserializeAws_restJson1DeleteVpcEndpointCommand
 */
export declare const de_DeleteVpcEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpcEndpointCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDomainCommand
 */
export declare const de_DescribeDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDomainAutoTunesCommand
 */
export declare const de_DescribeDomainAutoTunesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainAutoTunesCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDomainChangeProgressCommand
 */
export declare const de_DescribeDomainChangeProgressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainChangeProgressCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDomainConfigCommand
 */
export declare const de_DescribeDomainConfigCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainConfigCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDomainHealthCommand
 */
export declare const de_DescribeDomainHealthCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainHealthCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDomainNodesCommand
 */
export declare const de_DescribeDomainNodesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainNodesCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDomainsCommand
 */
export declare const de_DescribeDomainsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainsCommandOutput>;
/**
 * deserializeAws_restJson1DescribeDryRunProgressCommand
 */
export declare const de_DescribeDryRunProgressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDryRunProgressCommandOutput>;
/**
 * deserializeAws_restJson1DescribeInboundConnectionsCommand
 */
export declare const de_DescribeInboundConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInboundConnectionsCommandOutput>;
/**
 * deserializeAws_restJson1DescribeInstanceTypeLimitsCommand
 */
export declare const de_DescribeInstanceTypeLimitsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInstanceTypeLimitsCommandOutput>;
/**
 * deserializeAws_restJson1DescribeOutboundConnectionsCommand
 */
export declare const de_DescribeOutboundConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeOutboundConnectionsCommandOutput>;
/**
 * deserializeAws_restJson1DescribePackagesCommand
 */
export declare const de_DescribePackagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePackagesCommandOutput>;
/**
 * deserializeAws_restJson1DescribeReservedInstanceOfferingsCommand
 */
export declare const de_DescribeReservedInstanceOfferingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedInstanceOfferingsCommandOutput>;
/**
 * deserializeAws_restJson1DescribeReservedInstancesCommand
 */
export declare const de_DescribeReservedInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedInstancesCommandOutput>;
/**
 * deserializeAws_restJson1DescribeVpcEndpointsCommand
 */
export declare const de_DescribeVpcEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeVpcEndpointsCommandOutput>;
/**
 * deserializeAws_restJson1DissociatePackageCommand
 */
export declare const de_DissociatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DissociatePackageCommandOutput>;
/**
 * deserializeAws_restJson1GetCompatibleVersionsCommand
 */
export declare const de_GetCompatibleVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCompatibleVersionsCommandOutput>;
/**
 * deserializeAws_restJson1GetDataSourceCommand
 */
export declare const de_GetDataSourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDataSourceCommandOutput>;
/**
 * deserializeAws_restJson1GetDomainMaintenanceStatusCommand
 */
export declare const de_GetDomainMaintenanceStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDomainMaintenanceStatusCommandOutput>;
/**
 * deserializeAws_restJson1GetPackageVersionHistoryCommand
 */
export declare const de_GetPackageVersionHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPackageVersionHistoryCommandOutput>;
/**
 * deserializeAws_restJson1GetUpgradeHistoryCommand
 */
export declare const de_GetUpgradeHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUpgradeHistoryCommandOutput>;
/**
 * deserializeAws_restJson1GetUpgradeStatusCommand
 */
export declare const de_GetUpgradeStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUpgradeStatusCommandOutput>;
/**
 * deserializeAws_restJson1ListDataSourcesCommand
 */
export declare const de_ListDataSourcesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDataSourcesCommandOutput>;
/**
 * deserializeAws_restJson1ListDomainMaintenancesCommand
 */
export declare const de_ListDomainMaintenancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDomainMaintenancesCommandOutput>;
/**
 * deserializeAws_restJson1ListDomainNamesCommand
 */
export declare const de_ListDomainNamesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDomainNamesCommandOutput>;
/**
 * deserializeAws_restJson1ListDomainsForPackageCommand
 */
export declare const de_ListDomainsForPackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDomainsForPackageCommandOutput>;
/**
 * deserializeAws_restJson1ListInstanceTypeDetailsCommand
 */
export declare const de_ListInstanceTypeDetailsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListInstanceTypeDetailsCommandOutput>;
/**
 * deserializeAws_restJson1ListPackagesForDomainCommand
 */
export declare const de_ListPackagesForDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPackagesForDomainCommandOutput>;
/**
 * deserializeAws_restJson1ListScheduledActionsCommand
 */
export declare const de_ListScheduledActionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListScheduledActionsCommandOutput>;
/**
 * deserializeAws_restJson1ListTagsCommand
 */
export declare const de_ListTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsCommandOutput>;
/**
 * deserializeAws_restJson1ListVersionsCommand
 */
export declare const de_ListVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListVersionsCommandOutput>;
/**
 * deserializeAws_restJson1ListVpcEndpointAccessCommand
 */
export declare const de_ListVpcEndpointAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListVpcEndpointAccessCommandOutput>;
/**
 * deserializeAws_restJson1ListVpcEndpointsCommand
 */
export declare const de_ListVpcEndpointsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListVpcEndpointsCommandOutput>;
/**
 * deserializeAws_restJson1ListVpcEndpointsForDomainCommand
 */
export declare const de_ListVpcEndpointsForDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListVpcEndpointsForDomainCommandOutput>;
/**
 * deserializeAws_restJson1PurchaseReservedInstanceOfferingCommand
 */
export declare const de_PurchaseReservedInstanceOfferingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PurchaseReservedInstanceOfferingCommandOutput>;
/**
 * deserializeAws_restJson1RejectInboundConnectionCommand
 */
export declare const de_RejectInboundConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectInboundConnectionCommandOutput>;
/**
 * deserializeAws_restJson1RemoveTagsCommand
 */
export declare const de_RemoveTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RemoveTagsCommandOutput>;
/**
 * deserializeAws_restJson1RevokeVpcEndpointAccessCommand
 */
export declare const de_RevokeVpcEndpointAccessCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RevokeVpcEndpointAccessCommandOutput>;
/**
 * deserializeAws_restJson1StartDomainMaintenanceCommand
 */
export declare const de_StartDomainMaintenanceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartDomainMaintenanceCommandOutput>;
/**
 * deserializeAws_restJson1StartServiceSoftwareUpdateCommand
 */
export declare const de_StartServiceSoftwareUpdateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartServiceSoftwareUpdateCommandOutput>;
/**
 * deserializeAws_restJson1UpdateDataSourceCommand
 */
export declare const de_UpdateDataSourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDataSourceCommandOutput>;
/**
 * deserializeAws_restJson1UpdateDomainConfigCommand
 */
export declare const de_UpdateDomainConfigCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDomainConfigCommandOutput>;
/**
 * deserializeAws_restJson1UpdatePackageCommand
 */
export declare const de_UpdatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePackageCommandOutput>;
/**
 * deserializeAws_restJson1UpdateScheduledActionCommand
 */
export declare const de_UpdateScheduledActionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateScheduledActionCommandOutput>;
/**
 * deserializeAws_restJson1UpdateVpcEndpointCommand
 */
export declare const de_UpdateVpcEndpointCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateVpcEndpointCommandOutput>;
/**
 * deserializeAws_restJson1UpgradeDomainCommand
 */
export declare const de_UpgradeDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpgradeDomainCommandOutput>;
